#include "mainwindow.h"
#include "ui_mainwindow.h"

MainWindow::MainWindow(QWidget *parent)
    : QMainWindow(parent)
    , ui(new Ui::MainWindow)
{
    ui->setupUi(this);

    serie = new QSerialPort(QLatin1String("/dev/ttyACM0"));
    serie->setBaudRate(9600);

    ui->btnRojo->setEnabled(false);
    ui->btnVerde->setEnabled(false);
    ui->btnAzul->setEnabled(false);
}

MainWindow::~MainWindow()
{
    delete ui;
}


void MainWindow::on_btnRojo_clicked()
{
    static bool led_rojo = false;
    if (led_rojo) {
        serie->write(":R0b$");
        led_rojo = false;
    } else {
        serie->write(":R1c$");
        led_rojo = true;
    }
}

void MainWindow::on_btnVerde_clicked()
{
    static bool led_verde = false;
    if (led_verde) {
        serie->write(":G0w$");
        led_verde = false;
    } else {
        serie->write(":G1v$");
        led_verde = true;
    }
}

void MainWindow::on_btnAzul_clicked()
{
    static bool led_azul = false;
    if (led_azul) {
        serie->write(":B0r$");
        led_azul= false;
    } else {
        serie->write(":B1s$");
        led_azul = true;
    }
}

void MainWindow::on_btnAbreCierra_clicked()
{
    bool abre_ok;

    if (serie->isOpen()) {
           serie->close();
           ui->btnAbreCierra->setText("&Abrir puerto");

           ui->btnRojo->setEnabled(false);
           ui->btnVerde->setEnabled(false);
           ui->btnAzul->setEnabled(false);
    } else {
           abre_ok = serie->open(QIODevice::ReadWrite);

           if (abre_ok) {
               ui->btnAbreCierra->setText("&Cerrar puerto");

               ui->btnRojo->setEnabled(true);
               ui->btnVerde->setEnabled(true);
               ui->btnAzul->setEnabled(true);

           } else {
               ui->statusbar->showMessage(serie->errorString(), 5000);
           }
    }
}
